#ifndef _UDM_CACHE_H
#define _UDM_CACHE_H

#include "udm_config.h"
#include "udm_common.h"
#include "udm_services.h"

typedef struct {
	time_t	stamp;
	int	url_id;
	int	cmd;
	size_t	nwords;
} UDM_LOGD_CMD;

typedef struct {
	uint4	wrd_id;
	uint4	coord;
} UDM_LOGD_WRD;

typedef struct {
	time_t	stamp;
	int	url_id;
	uint4	wrd_id;
	uint4	coord;
} UDM_LOGWORD;

typedef struct {
	time_t	stamp;
	int	url_id; 
} UDM_LOGDEL;
/*
typedef struct{
	int url_id;
	uint4 coord;
} T_URL_CRD;
*/
extern int UdmOpenCache(UDM_ENV * Env, char *errmsg);
extern void UdmCloseCache(UDM_ENV  * Env);
extern int UdmClearCacheTree(UDM_ENV * Env);
extern __INDLIB__ int UdmSplitCacheLog(UDM_ENV * Env,int log,UDM_LOGDEL *buf,int del_count);
extern __INDLIB__ int RemoveDelLogDups(UDM_LOGDEL *words, int n);

extern int UdmStoreWordsCache(UDM_AGENT * Indexer,UDM_DOCUMENT * Doc);
extern UDM_URL_CRD *UdmFindCache(UDM_AGENT * Indexer,const char *q);
extern int UdmDeleteURLFromCache(UDM_AGENT *Indexer,int url_id);

extern void UdmDecodeHex8Str(const char *hex_str,uint4 *hi,uint4 *lo);

extern int UdmAddSearchLimit(UDM_AGENT *Agent, int type, const char *file_name, const char *val);

/************************** Logd stuff **************************/
#define MAX_LOG 4096
#define MAX_WRD 256 /* 256 => 4Kb */

#define open_flags O_WRONLY|O_CREAT|O_APPEND|UDM_BINARY
#define open_perm  UDM_IWRITE

typedef struct{
	UDM_LOGWORD data[MAX_WRD];
	size_t nrec;
}T_wrd_buf;

typedef struct{
	int		is_daemon;
	int		del_fd;
	char		time_pid[100];
	T_wrd_buf	wrd_buf[MAX_LOG];
	char		log_dir[1024];
	char		err_str[1024];
} UDM_LOGD;

UDM_LOGD LOGD;

extern char *Logd_time_pid_info(UDM_LOGD *logd);
extern int LogdInit(UDM_LOGD *logd,char* var_dir,int is_daemon);
extern int LogdClose(UDM_LOGD *logd);
extern int LogdSaveAllBufs(UDM_LOGD *logd);
extern int LogdStoreDoc(UDM_LOGD *logd,UDM_LOGD_CMD cmd,UDM_LOGD_WRD *wrd);

#endif
