#ifndef UDM_CHARSET_H
#define UDM_CHARSET_H

#define UDM_CHARSET_8859_1 0
#define UDM_CHARSET_8859_10 1
#define UDM_CHARSET_8859_11 2
#define UDM_CHARSET_8859_13 3
#define UDM_CHARSET_8859_14 4
#define UDM_CHARSET_8859_15 5
#define UDM_CHARSET_8859_16 6
#define UDM_CHARSET_8859_2 7
#define UDM_CHARSET_8859_3 8
#define UDM_CHARSET_8859_4 9
#define UDM_CHARSET_8859_5 10
#define UDM_CHARSET_8859_6 11
#define UDM_CHARSET_8859_7 12
#define UDM_CHARSET_8859_8 13
#define UDM_CHARSET_8859_9 14
#define UDM_CHARSET_ARMSCII_8 15
#define UDM_CHARSET_CP1250 16
#define UDM_CHARSET_CP1251 17
#define UDM_CHARSET_CP1252 18
#define UDM_CHARSET_CP1253 19
#define UDM_CHARSET_CP1254 20
#define UDM_CHARSET_CP1255 21
#define UDM_CHARSET_CP1256 22
#define UDM_CHARSET_CP1257 23
#define UDM_CHARSET_CP1258 24
#define UDM_CHARSET_CP437 25
#define UDM_CHARSET_CP850 26
#define UDM_CHARSET_CP852 27
#define UDM_CHARSET_CP855 28
#define UDM_CHARSET_CP857 29
#define UDM_CHARSET_CP860 30
#define UDM_CHARSET_CP861 31
#define UDM_CHARSET_CP862 32
#define UDM_CHARSET_CP863 33
#define UDM_CHARSET_CP864 34
#define UDM_CHARSET_CP865 35
#define UDM_CHARSET_CP866 36
#define UDM_CHARSET_CP869 37
#define UDM_CHARSET_CP874 38
#define UDM_CHARSET_KOI8_R 39
#define UDM_CHARSET_KOI8_U 40
#define UDM_CHARSET_US_ASCII 41
#define UDM_CHARSET_VISCII 42
#define UDM_CHARSET_X_MAC_CYRILLIC 43
#define UDM_CHARSET_UTF8 44
#define UDM_CHARSET_GB2312 45
#define UDM_CHARSET_BIG5 46
#define UDM_CHARSET_SJIS 47
#define UDM_CHARSET_EUC_KR 48

typedef struct{
	int (*from_uni)(char * str,const int * uni, size_t len);
	int (*to_uni)(int * uni, const char * str, size_t len);
} UDM_CHARSET;

/* Input string in xxx2uni                 */
/* convertion  has bad multi-byte sequence */
#define UDM_CHARSET_ILSEQ	0

/* Input buffer in xxx2uni was terminated  */
/* in the middle of multi-byte sequence    */
#define UDM_CHARSET_TOOFEW(n)	(-1-(n))

/* Output buffer in uni2xxx is too small */
#define UDM_CHARSET_TOOSMALL	-1

/* Some bytes where copied but an error accured */
#define UDM_CHARSET_ERROR(n)	(-1-(n))

/* Character types */
#define UDM_UNI_SEPAR	0
#define UDM_UNI_LETTER	1
#define UDM_UNI_DIGIT	2
#define UDM_UNI_CJK	3
#define UDM_UNI_MAX	3


extern int  UdmUniToLower(int uni);
extern void UdmUniStrToLower(int * unistr);
extern int  UdmUniStrCmp(const int * s1, const int * s2);
extern int  UdmUniStrNCaseCmp(const int * s1,const int * s2,size_t len);
extern int  UdmUniStrBCmp(const int *s1, const int *s2);
extern int  UdmUniStrBNCmp(const int *s1, const int *s2, size_t len);
extern int *UdmUniStrCpy(int *dst, const int *src);
extern int *UdmUniStrNCpy(int *dst, const int *src, size_t len);
extern int *UdmUniStrCat(int *s, const int *append);


extern size_t UdmUniLen(const int * u);
extern int *  UdmUniDup(const int * w);
extern int    UdmUniCType(int u);

extern int * UdmUniGetToken(int * s, int ** last);
extern int * UdmUniGetSepToken(int * s, int ** last);

extern UDM_CHARSET * UdmGetCharSet(const char * name);
extern  const char * UdmCharsetCanonicalName(const char * aslias);
#endif
