#include "udm_config.h"

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <ctype.h>
#include <sys/types.h>

#ifdef HAVE_UNISTD_H
#include <unistd.h>
#endif

#include "udm_utils.h"
#include "udm_common.h"
#include "udm_tag.h"
#include "udm_xmalloc.h"


/*********************** Tags ****************************/

int UdmFreeTag(UDM_TAG *tag){
	UDM_FREE(tag->tag);
	UDM_FREE(tag->href);
	UDM_FREE(tag->src);
	UDM_FREE(tag->content);
	UDM_FREE(tag->value);
	UDM_FREE(tag->selected);
	UDM_FREE(tag->name);
	UDM_FREE(tag->type);
	UDM_FREE(tag->lang);
	return(0);
}

int UdmParseTag(UDM_TAG *tag,char *stag){
char *s,*e,*p,*l;
int len;

	len=strlen(stag);s=stag+1; e=s;
	while(!strchr(" \t\r\n>",*e))e++; 
	*e=0;
	tag->tag=strdup(s);
	tag->href=NULL;
	tag->src=NULL;
	tag->content=NULL;
	tag->value=NULL;
	tag->selected=NULL;
	tag->name=NULL;
	tag->type=NULL;
	tag->lang = NULL;
	e++;
	UDM_SKIP(e," \t\r\n>");
	while(e-stag<len){
		s=e;
		UDM_SKIPN(e," \t\r\n=>");
		if(*e!='='){
			*e++=0;
			UDM_SKIP(e," \t\r\n>");
		}
		if(*e=='='){
			*e=0;e++;
			UDM_SKIP(e," \t\r\n>");
			p=e;
			if(*p=='"'){
				p++;e++;
				UDM_SKIPN(e,"\">");
			}else
			if(*p=='\''){
				p++;e++;
				UDM_SKIPN(e,"'>");
			}else{
				UDM_SKIPN(e," \t\r\n>");
			}
			*e=0;e++;

			/* Make lower string */
			for(l=s;*l;*l=tolower(*l),l++);

			/* This line to get statistics */
			/*printf("VAR %s\n",s);*/

			if(!strcmp(s,"charset")){					
				UDM_FREE(tag->name);
				UDM_FREE(tag->content);
				tag->name=strdup("Content-Type");
				tag->content=UdmXmalloc(9+strlen(p));
				strcpy(tag->content,"charset=");
				strcat(tag->content,p);
			}else
			if(!strcmp(s,"href")){		/* 50846 */
				UDM_FREE(tag->href);
				tag->href=strdup(UdmTrim(p," \r\n\t"));
			}else
			if(!strcmp(s,"name")){		/* 16987 */
				UDM_FREE(tag->name);
				tag->name=strdup(p);			
			}else
			if(!strcmp(s,"content")){	/* 4160 */
				UDM_FREE(tag->content);
				tag->content=strdup(p);
			}else
			if(!strcmp(s,"src")){		/* 2792 */
				UDM_FREE(tag->src);
				tag->src=strdup(UdmTrim(p," \r\n\t"));
			}else
			if(!strcmp(s,"http-equiv")){	/* 699 */
				UDM_FREE(tag->name);
				tag->name=strdup(p);
			}else
			if(!strcmp(s,"value")){		/* 22 */
				UDM_FREE(tag->value);
				tag->value=strdup(p);
			}else
			if(!strcmp(s,"selected")){
				UDM_FREE(tag->selected);
				tag->selected=strdup(p);
			}else
			if(!strcmp(s,"checked")){
				UDM_FREE(tag->selected);
				tag->selected=strdup(p);
			}else
			if(!strcmp(s,"type")){
				UDM_FREE(tag->type);
				tag->type=strdup(p);
			}else
			  if(!strcmp(s,"lang")){
			    UDM_FREE(tag->lang);
			    tag->lang=strdup(p);
			    tag->lang[0] = tolower(tag->lang[0]);
			    tag->lang[1] = tolower(tag->lang[1]);
			  }
		}
	}return(0);
}
